Subject: bug#8938: make timeout and CTRL-C

From: Pádraig Brady <[email-masked]>
Date: Sat, 02 Jul 2011 22:10:38 +0100

On 02/07/11 19:36, shay shimony wrote:
>> With this patch the child is guaranteed to not be in the foreground (as far
>> as the tty knows) so it will be getting SIGTTIN and possibly SIGTTOU on tty
>> operations.
> 
> You may need to correct me. In practice we see that the "timeouted"
> program perform successfully writes to the terminal, though it belongs
> to a different group then the foreground (in my case "make"'s group is
> in the foreground and timeout+compiler/test group is in the background,
> and all output of the compiler and test seem to appear correctly on the
> terminal). And regarding read, I think it makes sense enough that users
> will not use timeout for interactive programs that wait for input from
> the user.
> So maybe the fact that the timeouted program will not be able to get
> SIGTTIN and SIGTTOU is not such a disaster?

Whether output in a background group triggers SIGTTOU is configurable.
Also, in general a long running job might need input from the terminal at the start.

So I think it would be too restrictive to disallow programs that
read from tty from being timed out.

cheers,
Pádraig.